import { regionData } from 'element-china-area-data';


const Dictionaries = [
  {
    en:'fcontact',
    name:'联系人'
  },
  {
    en:'fphonenumber',
    name:'联系方式'
  },
  {
    en:'faddress',
    name:'地址'
  },
  {
    en:'fbrand',
    name:'品牌'
  },
  {
    en:'fwebsite',
    name:'企业网站'
  }
]
// 生成修改日志
let isObjectValueEqual = function (a, b, c) {   
  //取对象a和b的属性名
  var log = []
  var zn = []
  var result = []
  var aProps = Object.getOwnPropertyNames(a)
  for (var i = 0; i < aProps.length; i++) {
    var propName = aProps[i]
    if (a[propName] !== b[propName]) {
      propName === '__ob__'? log:log.push(propName)
    }
  }
  // 匹配中文字段
  log.forEach((e)=>{
    Dictionaries.forEach(element => {
      element.en === e?zn.push(element.name):''
    });
  },this)
  // 最终结果
  result.push({
    ftype: c === 'edit'?'修改':'新增',
    flog: zn.join(',')
  }) 
  return result
}
// 省市区编码转中文
let addressToZn = function (fprovince,fcity,fcounty) {
  var fprovince_zn = '' // eslint-disable-line no-unused-vars
  var fcity_zn = '' // eslint-disable-line no-unused-vars
  var fcounty_zn = '' // eslint-disable-line no-unused-vars
  regionData.forEach((fpr)=>{
    fpr.value === fprovince?fprovince_zn = fpr.label:''
    fpr.children.forEach((fci)=>{
      fci.value === fcity?fcity_zn = fci.label:''
      fci.children?fci.children.forEach(fco => {  // eslint-disable-line no-unused-vars
        fco.value === fcounty?fcounty_zn = fco.label:''
      },this):''
    },this)
  },this)
  let addres = fprovince_zn+'-'+fcity_zn+'-'+fcounty_zn
  return addres
}
// 导出excel
let exportExcel = function (a,b,c,d) {
    let formatJson = function(filterVal, jsonData) {
      return jsonData.map(v => filterVal.map(j => v[j]))
    }
    require.ensure([], () => {
    const { export_json_to_excel } = require('../excel/Export2Excel');
    const tHeader = a;  // 设置Excel的表格第一行的标题
    const filterVal = b;  // index、nickName、name是tableData里对象的属性
    const list = c;  //把data里的tableData存到list
    const data = formatJson(filterVal, list);
    export_json_to_excel(tHeader, data, d);  //导出Excel 文件名
  })
}
// 表格合并相同行
let mergeTableRow = function (data, merge) {
  if (!merge || merge.length === 0) {
    return data
  }
  merge.forEach((m) => {
    const mList = {}
    data = data.map((v, index) => {
      const rowVal = v[m]
      if (mList[rowVal] && mList[rowVal].newIndex === index) {
        mList[rowVal]['num']++
        mList[rowVal]['newIndex']++
        data[mList[rowVal]['index']][m + '-span'].rowspan++
        v[m + '-span'] = {
          rowspan: 0,
          colspan: 0
        }
      } else {
        mList[rowVal] = { num: 1, index: index, newIndex: index + 1 }
        v[m + '-span'] = {
          rowspan: 1,
          colspan: 1
        }
      }
      return v
    })
  })
  return data
}
export default {
  isObjectValueEqual,
  addressToZn,
  exportExcel,
  mergeTableRow
}